#!/bin/sh

# Atomic Clamav rule updater
# GPLv3
# VERSION 0.2
# TODO 
#  - need to add a validation routine for update


clamscan="/usr/bin/clamscan"

clam_sigs="/var/clamav"
tmpdir="/var/tmp/clamav"

if [ -f /etc/clamd.conf ]; then
  clam_user=$(awk '/^User/ {print $2}' /etc/clamd.conf)
else
  clam_user="clamav"
fi

if [ ! -d $tmpdir ]; then
  mkdir $tmpdir
fi

cd $tmpdir



#  get_update <file> <url> <destination> 
function get_update {
  file=$1
  url=$2

  # get new file
  wget -q -O $file $url/$file

  # If file is not 0 size, apply it
  test -s $file     && \
	clamscan --quiet -d $file - < /dev/null  && \
	mv $file $clam_sigs

}

#  get_update <file> <url> <destination> 
function get_update_gz {
  file=$1
  url=$2
  new=`echo $file |sed 's/\.gz//'`

  # get new file
  wget -q -O $file $url/$file 

  # If file is not 0 size, apply it
  test -s $file     && \
	zcat $file > $new && \
	rm -f $file && \
	clamscan --quiet -d $new - < /dev/null  && \
	mv $new $clam_sigs

}

#Secureiteinfo  Database Update
echo -n "Updating Securiteinfo Databases: "
get_update_gz vx.hdb.gz http://www.atomicorp.com/signatures/clamav/securiteinfo/ 
echo -n "VX "
get_update_gz securiteinfo.hdb.gz http://www.atomicorp.com/signatures/clamav/securiteinfo/ 
echo -n "Securityinfo "
get_update_gz honeynet.hdb.gz http://www.atomicorp.com/signatures/clamav/securiteinfo/ 
echo -n "Honeynet "
echo

echo -n "Updating malware.com.br Databases: "
get_update mbl.db http://www.atomicorp.com/signatures/clamav/mbl/
echo "MBL"


echo -n "Updating MSRBL Databases: "
get_update MSRBL-Images-FULL-SoN.hdb http://www.atomicorp.com/signatures/clamav/msrbl/
echo -n "Images "
get_update MSRBL-SPAM.ndb http://www.atomicorp.com/signatures/clamav/msrbl/
echo -n "Spam "
echo

echo -n "Updating Sanesecurity Databases: "
get_update  junk.ndb http://www.atomicorp.com/signatures/clamav/sanesecurity/
echo -n "junk "
get_update  lott.ndb http://www.atomicorp.com/signatures/clamav/sanesecurity/
echo -n "lott "
get_update  phish.ndb http://www.atomicorp.com/signatures/clamav/sanesecurity/
echo -n "phish "
get_update  rogue.hdb http://www.atomicorp.com/signatures/clamav/sanesecurity/
echo -n "rouge "
get_update  scam.ndb http://www.atomicorp.com/signatures/clamav/sanesecurity/
echo -n "scam "
get_update  spamimg.hdb http://www.atomicorp.com/signatures/clamav/sanesecurity/
get_update  spam.ldb http://www.atomicorp.com/signatures/clamav/sanesecurity/
echo -n "spamming "
get_update  spear.ndb http://www.atomicorp.com/signatures/clamav/sanesecurity/
echo -n "spear "
echo


# Cleanup
rm -rf $tmpdir

# Set appropriate file access permissions
chown -R $clam_user:$clam_user $clam_sigs


